



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Socket编程实践(1) 基本概念</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Socket编程实践(1) 基本概念</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 10:46:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1. 什么是socket</h1>
<p>socket可以看成是用户进程与内核网络协议栈的编程接口。TCP/IP协议的底层部分已经被内核实现了，而应用层是用户需要实现的，这部分程序工作在用户空间。用户空间的程序需要通过套接字来访问内核网络协议栈。</p>
<p>套接口是全双工的通信，它不仅可以用于本机的进程间通信，还可以用于网络上不同主机的进程间通信。</p>
<p>套接字还可以<strong>异构系统</strong>间进行通信，异构系统指的是在硬件或软件上有所差别的系统，例如安卓系统的手机与windows系统的PC机上都可以实现QQ通信，套接字可以实现在这两个设备上的通信。</p>
<h1>2. IPV4套接口地址结构</h1>
<p>套接口既然能够连接两个端系统，那它就需要一个地址来标记该端系统，例如两个电话需要电话号码来标记才可以进行拨号。这抽象成套接口的地址结构。IPV4套接口地址结构通常也称为“网际套接字地址结构”，它以<strong>sockaddr_in</strong>命名，定义在头文件<strong>&lt; netinet/in/h &gt;</strong>中。</p>
<pre class="prettyprint linenums"><code><br />
struct sockaddr_in{

    uint8_t sin_len;

    sa_family_t sin_family;

    in_port_t sin_port;

    struct in_addr sin_addr;

    char sin_zero[8];

};

</code></pre>
<p>说明：</p>
<ol><li>sin_len:整个sockaddr_in结构体的长度，在4.3BSD-Reno版本之前的第一个成员是sin_family。</li>
<li>sin_family:指定带地址家族，在这里必须设置为AF_INET。socket在设计时不仅可以用于TCP/IP协议，它还可以用于其他协议，例如unix域协议，地址家族用于指定该套接字用于哪种协议。AF_INET表示用于IPV4协议。</li>
<li>sin_port:端口号，16位的无符号整数，能够表示到65535。2个字节。</li>
<li>sin_addr: IPV4的地址。4个字节的整数。</li>
<li>sin_zero:暂不使用，一般将其设置为0。</li></ol>
<p>其中，struct in_addr仅仅是一个32位的无符号整数，可以在终端下输入man 7 ip进行查看：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/610439/201604/610439-20160424113949210-1573706662.png"></p>
<p>接下来看一下通用的地址结构。上面说过，socket可以用于不同的协议上，通用的地址结构可以用于任何协议的socket编程。</p>
<pre class="prettyprint linenums"><code><br />
struct sockaddr{

    uint8_t sin_len;

    sa_family sin_family;

    char sa_data[14];

};

</code></pre>
<p>说明：</p>
<ol><li>sin_len:整个sockaddr结构大小</li>
<li>sin_family:指定该地址家族</li>
<li>sa_data:由sin_family决定它的形式</li></ol>
<p>可以看到，在通用地址结构中sa_data是14个字节，而在IPV4的地址结构中，sin_port、sin_addr、sin_zero三个变量加起来也等于14个字节。也即是说，这两种结构是兼容的。</p>
<h1>3. 网络字节序</h1>
<p>字节序可以分为大端字节序与小端字节序：</p>
<ul><li>大端字节序(Big Endian) :最高有效位存储于最低内存地址处，最低有效位存储于最高地址内存处。</li>
<li>小端字节序(Little Endian):刚好与大端字节序倒过来，最高有效位存于最高内存地址处，最低有效位存储于最低内存地址处。</li></ul>
<p>这样说起来挺抽象，通过一幅图来说明：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/610439/201604/610439-20160424113956866-669078658.png"></p>
<p>上面说过，socket可以用于异构系统之间的通信。而不同的系统采用的字节序可能是不同的，有的系统采用大端字节序，例如Motorola 6800；有的采用小端字节序，如X86。因此，在进行字节传输时，应该同一一个字节序，称为网络字节序。<strong>网络字节序采用大端字节序</strong>。如果主机A为小端字节序的系统，那么在传输时需要先将小端字节序转换成网络字节序。这需要一些字节序的转换函数。</p>
<p>我们可以编写程序来测试自己的主机是什么字节序：</p>
<pre class="prettyprint linenums"><code><br />
#include&lt;stdio.h&gt;

int main(void)

{

        unsigned int x = 0x12345678;

        unsigned char *p = (unsigned char*)&amp;x;

        printf(&quot;%0x,%0x,%0x,%0x\n&quot;,p[0],p[1],p[2],p[3]);

        return 0;

} 

</code></pre>
<p>在我的电脑上输出结果为：78,56,34,12. 因此我的主机为小端字节序。</p>
<h1>4. 字节序转换函数</h1>
<p>如果主机的字节序与网络字节序不同，那么需要进行字节序的转换。下面是一些字节序转换函数：</p>
<pre class="prettyprint linenums"><code>   # include &lt; arpa/inet.h &gt;

   uint32_t htonl(uint32_t hostlong);

   uint16_t htons(uint16_t hostshort);

   uint32_t ntohl(uint32_t netlong);

   uint16_t ntohs(uint16_t netshort);<br />
</code></pre>
<p>说明：h代表host；n代表network；s代表short；l代表long</p>
<p>描述：</p>
<ul><li>htonl()函数将无符号整数hostlong从主机字节序转换成网络字节序。</li>
<li>htons()函数将无符号短整型hostshort从主机字节序转换成网络字节序。</li>
<li>ntohl()函数功能与 htonl()函数相反</li>
<li>ntohs()函数功能与htons()函数相反</li></ul>
<p>我们可以进行验证，刚才已经通过程序测试出我的主机是小端字节序，接下来使用函数 htonl()将整数0x12345678转换成网络字节序。</p>
<pre class="prettyprint linenums"><code><br />
#include&lt;stdio.h&gt;

#include &lt;arpa/inet.h&gt;

int main(void)

{

        unsigned int x = 0x12345678;

        unsigned char *p = (unsigned char*)&amp;x;

        printf(&quot;转换前：%0x,%0x,%0x,%0x\n&quot;,p[0],p[1],p[2],p[3]);

        unsigned int y = htonl(x);

        p = (unsigned char *) &amp;y;

        printf(&quot;转换后：%0x,%0x,%0x,%0x\n&quot;,p[0],p[1],p[2],p[3]);

        return 0;

}         

</code></pre>
<p>结果输出：</p>
<p>转换前：78,56,34,12</p>
<p>转换后：12,34,56,78</p>
<h1>5. 地址转换函数</h1>
<p>对于IP地址，我们通常采用点分十进制的形式进行直观的认识，而程序更多的时候是处理32位的地址，因此需要有函数在点分十进制与32位地址这两种形式间进行转换。</p>
<pre class="prettyprint linenums"><code>   # include &lt; sys/socket.h&gt;

   # include &lt; netinet/in.h&gt;

   # include &lt; arpa/inet.h&gt;

   int inet_aton(const char *cp, struct in_addr *inp);

   in_addr_t inet_addr(const char *cp);

   char *inet_ntoa(struct in_addr in);<br />
</code></pre>
<p>描述：</p>
<ul><li>inet_addr()函数：表示将点分十进制的IP地址转换成32位的ip地址（整数）。</li>
<li>inet_ntoa()函数：将32位ip地址（网络字节序）转换成点分十进制的ip之地。</li></ul>
<p>例程：</p>
<pre class="prettyprint linenums"><code><br />
#include&lt;stdio.h&gt;

#include&lt;arpa/inet.h&gt;

int main()

{

        unsigned long addr = inet_addr(&quot;192.168.0.100&quot;);//将点分十进制转换为32bit地址

        printf(&quot;addr = %u\n&quot;,htonl(addr)); 

        struct in_addr ipaddr;

        ipaddr.s_addr = addr;

        printf(&quot;ipaddr = %s\n&quot;,inet_ntoa(ipaddr)); //网络字节序地址转换为点分十&gt;进制

        return 0;

}

</code></pre>
<p>输出：</p>
<p>addr = 3232235620</p>
<p>ipaddr = 192.168.0.100</p>
<h1>6. 套接字类型</h1>
<p>套接字类型主要有三种：</p>
<ol><li>流方套接字（SOCK_STREAM）：它对应TCP协议，它提供面向连接的、可靠的数据传输服务，数据无差错、无重复的发送，且按发送顺序接收。</li>
<li>数据报套接字（SOCK_DGREAM)：提供无连接服务。不提供无错保证，数据可能丢失或重复，并且接收顺序混乱。</li>
<li>原始套接字（SOCK_RAW）:它提供一种能力，让我们直接跨越传输层，直接对IP层进行数据封装，通过该套接字，我们可以直接将数据封装成IP层能够认识的协议格式。</li></ol>
<p>文章连接：<a href="http://www.cnblogs.com/QG-whz/p/5426634.html" rel="external nofollow noreferrer">http://www.cnblogs.com/QG-whz/p/5426634.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q25wxxq.html">HW2016&lowbar;字符串&lowbar;STL&lowbar;DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlljwkq.html">Pyserial操作串口</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3g1p8.html">好文推荐系列---------JS模板引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96levj9.html">Stealth视频教程学习笔记（第二章）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ol5p18.html">caffe pytho接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdxoxx8.html">Highcharts使用简例 &plus; 异步动态读取数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m6jy69.html">设计模式学习之命令模式（Command，行为型模式）（12）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k32n3q.html">二进制流 最后一段数据是最后一次读取的byte数组没填满造成的</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2gdd8.html">Android系统编译脚本理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok5lx19.html">Ajax异步操作集合啦（阿贾克斯）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1l178.html">MVC  中与链接相关的辅助方法&lpar;Html&period;ActionLink&comma;Html&period;RouteLink &comma; Url&period;Action  &comma; Url&period;Content &comma;Url&period;RouteUrl&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7md0ykq.html">iOS本地数据存取</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vl2648.html">自编的CHtmlView浏览器，怎么截获超连接，不让新窗口在IE中打开</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgdyjq.html">css组件规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp04e0q.html">Menu的自己定义实现-------保卫萝卜造塔升级塔菜单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjl7x8.html">ABP项目中的使用AutoMapper</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypzor8.html">UVa 11426</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gex7g48.html">Javascript流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll76n6q.html">The Chinese Postman Problem HIT - 2739&lpar;有向图中国邮路问题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g45neq.html">Android&period;Tools&period;Ant</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495xrme8.html">谈一谈前端多容器（多webview平台）处理方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4yyjeq.html">Oracle研究专题：Oracle系统安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1zzp09.html">Dynamics CRM 之ADFS 使用 SQL Server 的联合服务器场</a>
			</li>
						<li><a href="https://www.batexi.com/a/390vvlo8.html">Android简单介绍SharedPreference&comma;内部文件&comma;sdcard数据存储</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlml3x9.html">JavaScript线程机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k1o139.html">原创 C&plus;&plus;之常量（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qydvlxq.html">MySQL备份锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvvzloq.html">阿里云ECS服务器配置（Ubuntu&plus;JAVA&plus;Tomcat&plus;Mysql）</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e1w2k9.html">webgl 循环传参画10个点</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlmv3k9.html">AndroidStudio中make Project、clean Project、Rebuild Project的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
